﻿using Harmony;
using System;
using System.IO;
using System.Reflection;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class SaveAnywhere : Mod
{
    HarmonyInstance instance;
    public void Start()
    {
        instance = HarmonyInstance.Create("fr.tekgamer.saveanywhere");
        instance.PatchAll(Assembly.GetExecutingAssembly());
        Debug.Log("Mod SaveAnywhere has been loaded!");
    }

    [ConsoleCommand("savegame", "Shows you the menu to save the current game.")]
    public static void Save()
    {
        if (ReplTools.IsPlayingAlone() || ReplTools.AmIMaster())
        {
            MenuInGameManager.Get().ShowScreen(typeof(SaveGameMenu));
            return;
        }
        Player.Get().GetPlayerComponent<ReplicatedLogicalPlayer>().RequestSave();
    }

    public void OnModUnload()
    {
        GameObject InGameMenu = GameObject.Find("InGameMenu");
        if (InGameMenu.transform.Find("MenuInGame").Find("Buttons").Find("SaveAnywhere") != null)
        {
            Destroy(InGameMenu.transform.Find("MenuInGame").Find("Buttons").Find("SaveAnywhere").gameObject);
        }
        instance.UnpatchAll();
        Debug.Log("Mod SaveAnywhere has been unloaded!");
    }
}

[HarmonyPatch(typeof(MenuInGame))]
[HarmonyPatch("OnShow")]
internal class Patch_MenuInGame_AddButton
{
    public static void Prefix(MenuInGame __instance)
    {
        GameObject InGameMenu = GameObject.Find("InGameMenu");
        if (InGameMenu.transform.Find("MenuInGame").Find("Buttons").Find("SaveAnywhere") == null)
        {
            GameObject btn = GameObject.Instantiate(InGameMenu.transform.Find("MenuInGame").Find("Buttons").Find("Resume").gameObject, InGameMenu.transform.Find("MenuInGame").Find("Buttons"));
            btn.name = "SaveAnywhere";
            btn.GetComponent<UIButtonEx>().onClick.AddListener(SaveAnywhere.Save);
            InGameMenu.transform.Find("MenuInGame").GetComponent<MenuInGame>().AddMenuButton(btn.GetComponent<UIButtonEx>(), "SAVE GAME FROM ANYWHERE");
            btn.GetComponentInChildren<Text>().text = "SAVE GAME FROM ANYWHERE";
        }
    }
}